/* restricted */
/* AUTOGENERATED FROM web-client_test.rules
alert tcp $EXTERNAL_NET $HTTP_PORTS -> $HOME_NET any (msg:"pcre in normalized buffer, single escape"; flow:to_client,established; content:"IIS 7.5 Detailed Error - 404.0 - Not Found"; nocase; pcre:"/IIS 7\x2e5 Detailed Error - 404\x2e0 - Not Found/i"; metadata:policy balanced-ips drop, policy security-ips drop, service http; reference:cve,2010-3936; reference:url,www.microsoft.com/technet/security/bulletin/MS10-089.mspx; classtype:attempted-admin; sid:64111; rev:1;)
alert tcp $EXTERNAL_NET any -> $HOME_NET $HTTP_PORTS (msg:"pcre in uri, single escape"; flow:to_server, established; content:"signurl|2E|asp"; fast_pattern; nocase; http_uri; content:"SignUrl="; nocase; http_uri; pcre:"/SignUrl=[^\x26\s]*[\x22\x27\x28\x29\x3C\x3E]/Ui"; metadata:policy balanced-ips drop, policy security-ips drop, service http; reference:cve,2010-3936; reference:url,www.microsoft.com/technet/security/bulletin/MS10-089.mspx; classtype:attempted-admin; sid:64222; rev:1;)
alert tcp $EXTERNAL_NET any -> $HOME_NET $HTTP_PORTS (msg:"pcre in uri, double escape"; flow:to_server, established; content:"signurl|2E|asp"; fast_pattern; nocase; http_uri; content:"SignUrl="; nocase; http_uri; pcre:"/SignUrl=[^\\x26\\s]*[\\x22\\x27\\x28\\x29\\x3C\\x3E]/Ui"; metadata:policy balanced-ips drop, policy security-ips drop, service http; reference:cve,2010-3936; reference:url,www.microsoft.com/technet/security/bulletin/MS10-089.mspx; classtype:attempted-admin; sid:64333; rev:1;)
*/
/*
 * Vuln Title: XXXX
 *
 * Copyright (C) 2014-2021 Cisco and/or its affiliates. All rights reserved.
 * Copyright (C) 2005-2013 Sourcefire, Inc. All Rights Reserved
 *
 * Written by XXXX, Sourcefire VRT <XXXX@sourcefire.com>
 *
 * Auto-generated by XXXX
 *
 * This file may contain proprietary rules that were created, tested and
 * certified by Sourcefire, Inc. (the "VRT Certified Rules") as well as
 * rules that were created by Sourcefire and other third parties and
 * distributed under the GNU General Public License (the "GPL Rules").  The
 * VRT Certified Rules contained in this file are the property of
 * Sourcefire, Inc. Copyright 2005 Sourcefire, Inc. All Rights Reserved.
 * The GPL Rules created by Sourcefire, Inc. are the property of
 * Sourcefire, Inc. Copyright 2002-2005 Sourcefire, Inc. All Rights
 * Reserved.  All other GPL Rules are owned and copyrighted by their
 * respective owners (please see www.snort.org/contributors for a list of
 * owners and their respective copyrights).  In order to determine what
 * rules are VRT Certified Rules or GPL Rules, please refer to the VRT
 * Certified Rules License Agreement.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "sf_snort_plugin_api.h"
#include "sf_snort_packet.h"


/* declare detection functions */
int rule64111eval(void *p);
int rule64222eval(void *p);
int rule64333eval(void *p);

/* declare rule data structures */
/* flow:established, to_client; */
static FlowFlags rule64111flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_CLIENT
};

static RuleOption rule64111option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule64111flow0
    }
};
// content:"IIS 7.5 Detailed Error - 404.0 - Not Found", depth 0, nocase, fast_pattern; 
static ContentInfo rule64111content1 = 
{
    (u_int8_t *) "IIS 7.5 Detailed Error - 404.0 - Not Found", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_FAST_PATTERN|CONTENT_BUF_NORMALIZED, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0, /* increment length*/
    0,                      /* holder for fp offset */
    0,                      /* holder for fp length */
    0,                      /* holder for fp only */
    NULL, // offset_refId
    NULL, // depth_refId
    NULL, // offset_location
    NULL  // depth_location
};

static RuleOption rule64111option1 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule64111content1
    }
};

// pcre:"IIS 7\x2e5 Detailed Error - 404\x2e0 - Not Found", nocase;
static PCREInfo rule64111pcre2 =
{
    "IIS 7\\x2e5 Detailed Error - 404\\x2e0 - Not Found", /* pattern */
    NULL,                               /* holder for compiled pattern */
    NULL,                               /* holder for compiled pattern flags */
    PCRE_CASELESS,     /* compile flags */
    CONTENT_BUF_NORMALIZED,     /* content flags */
    0 /* offset */
};

static RuleOption rule64111option2 =
{
    OPTION_TYPE_PCRE,
    {
        &rule64111pcre2
    }
};

/* references for sid 64111 */
/* reference: cve "2010-3936"; */
static RuleReference rule64111ref1 = 
{
    "cve", /* type */
    "2010-3936" /* value */
};

/* reference: url "www.microsoft.com/technet/security/bulletin/MS10-089.mspx"; */
static RuleReference rule64111ref2 = 
{
    "url", /* type */
    "www.microsoft.com/technet/security/bulletin/MS10-089.mspx" /* value */
};

static RuleReference *rule64111refs[] =
{
    &rule64111ref1,
    &rule64111ref2,
    NULL
};
/* metadata for sid 64111 */
/* metadata:service http, policy balanced-ips drop, policy security-ips drop; */
static RuleMetaData rule64111service1 = 
{
    "service http"
};


static RuleMetaData rule64111policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule64111policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule64111metadata[] =
{
    &rule64111service1,
    &rule64111policy1,
    &rule64111policy2,
    NULL
};

RuleOption *rule64111options[] =
{
    &rule64111option0,
    &rule64111option1,
    &rule64111option2,
    NULL
};

Rule rule64111 = {
   /* rule header, akin to => tcp any any -> any any */
   {
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "$HTTP_PORTS", /* SRCPORT   */
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
       "any", /* DSTPORT   */
   },
   /* metadata */
   { 
       3,  /* genid */
       64111, /* sigid */
       1, /* revision */
       "attempted-admin", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "pcre in normalized buffer, single escape",     /* message */
       rule64111refs /* ptr to references */
       ,rule64111metadata
   },
   rule64111options, /* ptr to rule options */
   NULL, // &rule64111eval, /* use the built in detection function */
   0, /* am I initialized yet? */
   0,                                  /* Rule option count, used internally */
   0,                                  /* Flag with no alert, used internally */
   NULL /* ptr to internal data... setup during rule registration */
};
/* flow:established, to_server; */
static FlowFlags rule64222flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_SERVER
};

static RuleOption rule64222option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule64222flow0
    }
};
// content:"signurl.asp", payload http_uri, depth 0, nocase, fast_pattern; 
static ContentInfo rule64222content1 = 
{
    (u_int8_t *) "signurl.asp", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_FAST_PATTERN|CONTENT_BUF_URI, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0, /* increment length */
    0,                      /* holder for fp offset */
    0,                      /* holder for fp length */
    0,                      /* holder for fp only */
    NULL, // offset_refId
    NULL, // depth_refId
    NULL, // offset_location
    NULL  // depth_location
};

static RuleOption rule64222option1 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule64222content1
    }
};
// content:"SignUrl=", payload http_uri, depth 0, nocase; 
static ContentInfo rule64222content2 = 
{
    (u_int8_t *) "SignUrl=", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_BUF_URI, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0, /* increment length */
    0,                      /* holder for fp offset */
    0,                      /* holder for fp length */
    0,                      /* holder for fp only */
    NULL, // offset_refId
    NULL, // depth_refId
    NULL, // offset_location
    NULL  // depth_location
};

static RuleOption rule64222option2 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule64222content2
    }
};

// pcre:"SignUrl=[^\x26\s]*[\x22\x27\x28\x29\x3C\x3E]", payload uri, nocase;
static PCREInfo rule64222pcre3 =
{
    "SignUrl=[^\\x26\\s]*[\\x22\\x27\\x28\\x29\\x3C\\x3E]", /* pattern */
    NULL,                               /* holder for compiled pattern */
    NULL,                               /* holder for compiled pattern flags */
    PCRE_CASELESS,     /* compile flags */
    CONTENT_BUF_URI,     /* content flags */
    0 /* offset */
};

static RuleOption rule64222option3 =
{
    OPTION_TYPE_PCRE,
    {
        &rule64222pcre3
    }
};

/* references for sid 64222 */
/* reference: cve "2010-3936"; */
static RuleReference rule64222ref1 = 
{
    "cve", /* type */
    "2010-3936" /* value */
};

/* reference: url "www.microsoft.com/technet/security/bulletin/MS10-089.mspx"; */
static RuleReference rule64222ref2 = 
{
    "url", /* type */
    "www.microsoft.com/technet/security/bulletin/MS10-089.mspx" /* value */
};

static RuleReference *rule64222refs[] =
{
    &rule64222ref1,
    &rule64222ref2,
    NULL
};
/* metadata for sid 64222 */
/* metadata:service http, policy balanced-ips drop, policy security-ips drop; */
static RuleMetaData rule64222service1 = 
{
    "service http"
};


static RuleMetaData rule64222policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule64222policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule64222metadata[] =
{
    &rule64222service1,
    &rule64222policy1,
    &rule64222policy2,
    NULL
};

RuleOption *rule64222options[] =
{
    &rule64222option0,
    &rule64222option1,
    &rule64222option2,
    &rule64222option3,
    NULL
};

Rule rule64222 = {
   /* rule header, akin to => tcp any any -> any any */
   {
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "any", /* SRCPORT   */
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
       "$HTTP_PORTS", /* DSTPORT   */
   },
   /* metadata */
   { 
       3,  /* genid */
       64222, /* sigid */
       1, /* revision */
       "attempted-admin", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "pcre in uri, single escape",     /* message */
       rule64222refs /* ptr to references */
       ,rule64222metadata
   },
   rule64222options, /* ptr to rule options */
   NULL, // &rule64222eval, /* use the built in detection function */
   0, /* am I initialized yet? */
   0,                                  /* Rule option count, used internally */
   0,                                  /* Flag with no alert, used internally */
   NULL /* ptr to internal data... setup during rule registration */
};
/* flow:established, to_server; */
static FlowFlags rule64333flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_SERVER
};

static RuleOption rule64333option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule64333flow0
    }
};
// content:"signurl.asp", payload http_uri, depth 0, nocase, fast_pattern; 
static ContentInfo rule64333content1 = 
{
    (u_int8_t *) "signurl.asp", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_FAST_PATTERN|CONTENT_BUF_URI, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0, /* increment length */
    0,                      /* holder for fp offset */
    0,                      /* holder for fp length */
    0,                      /* holder for fp only */
    NULL, // offset_refId
    NULL, // depth_refId
    NULL, // offset_location
    NULL  // depth_location
};

static RuleOption rule64333option1 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule64333content1
    }
};
// content:"SignUrl=", payload http_uri, depth 0, nocase; 
static ContentInfo rule64333content2 = 
{
    (u_int8_t *) "SignUrl=", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_BUF_URI, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0, /* increment length */
    0,                      /* holder for fp offset */
    0,                      /* holder for fp length */
    0,                      /* holder for fp only */
    NULL, // offset_refId
    NULL, // depth_refId
    NULL, // offset_location
    NULL  // depth_location
};

static RuleOption rule64333option2 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule64333content2
    }
};

// pcre:"SignUrl=[^\\x26\\s]*[\\x22\\x27\\x28\\x29\\x3C\\x3E]", payload uri, nocase;
static PCREInfo rule64333pcre3 =
{
    "SignUrl=[^\\\\x26\\\\s]*[\\\\x22\\\\x27\\\\x28\\\\x29\\\\x3C\\\\x3E]", /* pattern */
    NULL,                               /* holder for compiled pattern */
    NULL,                               /* holder for compiled pattern flags */
    PCRE_CASELESS,     /* compile flags */
    CONTENT_BUF_URI,     /* content flags */
    0 /* offset */
};

static RuleOption rule64333option3 =
{
    OPTION_TYPE_PCRE,
    {
        &rule64333pcre3
    }
};

/* references for sid 64333 */
/* reference: cve "2010-3936"; */
static RuleReference rule64333ref1 = 
{
    "cve", /* type */
    "2010-3936" /* value */
};

/* reference: url "www.microsoft.com/technet/security/bulletin/MS10-089.mspx"; */
static RuleReference rule64333ref2 = 
{
    "url", /* type */
    "www.microsoft.com/technet/security/bulletin/MS10-089.mspx" /* value */
};

static RuleReference *rule64333refs[] =
{
    &rule64333ref1,
    &rule64333ref2,
    NULL
};
/* metadata for sid 64333 */
/* metadata:service http, policy balanced-ips drop, policy security-ips drop; */
static RuleMetaData rule64333service1 = 
{
    "service http"
};


static RuleMetaData rule64333policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule64333policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule64333metadata[] =
{
    &rule64333service1,
    &rule64333policy1,
    &rule64333policy2,
    NULL
};

RuleOption *rule64333options[] =
{
    &rule64333option0,
    &rule64333option1,
    &rule64333option2,
    &rule64333option3,
    NULL
};

Rule rule64333 = {
   /* rule header, akin to => tcp any any -> any any */
   {
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "any", /* SRCPORT   */
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
       "$HTTP_PORTS", /* DSTPORT   */
   },
   /* metadata */
   { 
       3,  /* genid */
       64333, /* sigid */
       1, /* revision */
       "attempted-admin", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "pcre in uri, double escape",     /* message */
       rule64333refs /* ptr to references */
       ,rule64333metadata
   },
   rule64333options, /* ptr to rule options */
   NULL, // &rule64333eval, /* use the built in detection function */
   0, /* am I initialized yet? */
   0,                                  /* Rule option count, used internally */
   0,                                  /* Flag with no alert, used internally */
   NULL /* ptr to internal data... setup during rule registration */
};


/* detection functions */
// #if 0 // Don't compile the detection functions if they're not used
int rule64111eval(void *p) {
    const u_int8_t *cursor_normal = 0;
    SFSnortPacket *sp = (SFSnortPacket *) p;

    if(sp == NULL)
        return RULE_NOMATCH;

    if(sp->payload == NULL)
        return RULE_NOMATCH;
    
    // flow:established, to_client;
    if (checkFlow(p, rule64111options[0]->option_u.flowFlags) > 0 ) {
        // content:"IIS 7.5 Detailed Error - 404.0 - Not Found", depth 0, nocase, fast_pattern;
        if (contentMatch(p, rule64111options[1]->option_u.content, &cursor_normal) > 0) {
            // pcre:"IIS 7\x2e5 Detailed Error - 404\x2e0 - Not Found", nocase;
            if (pcreMatch(p, rule64111options[2]->option_u.pcre, &cursor_normal)) {
                return RULE_MATCH;
            }
        }
    }
    return RULE_NOMATCH;
}
int rule64222eval(void *p) {
    //const u_int8_t *cursor_normal = 0;
    const u_int8_t *cursor_http_uri = 0;
    const u_int8_t *cursor_uri = 0;
    SFSnortPacket *sp = (SFSnortPacket *) p;

    if(sp == NULL)
        return RULE_NOMATCH;

    if(sp->payload == NULL)
        return RULE_NOMATCH;
    
    // flow:established, to_server;
    if (checkFlow(p, rule64222options[0]->option_u.flowFlags) > 0 ) {
        // content:"signurl.asp", payload http_uri, depth 0, nocase, fast_pattern;
        if (contentMatch(p, rule64222options[1]->option_u.content, &cursor_http_uri) > 0) {
            // content:"SignUrl=", payload http_uri, depth 0, nocase;
            if (contentMatch(p, rule64222options[2]->option_u.content, &cursor_http_uri) > 0) {
                // pcre:"SignUrl=[^\x26\s]*[\x22\x27\x28\x29\x3C\x3E]", payload uri, nocase;
                if (pcreMatch(p, rule64222options[3]->option_u.pcre, &cursor_uri)) {
                    return RULE_MATCH;
                }
            }
        }
    }
    return RULE_NOMATCH;
}
int rule64333eval(void *p) {
    //const u_int8_t *cursor_normal = 0;
    const u_int8_t *cursor_http_uri = 0;
    const u_int8_t *cursor_uri = 0;
    SFSnortPacket *sp = (SFSnortPacket *) p;

    if(sp == NULL)
        return RULE_NOMATCH;

    if(sp->payload == NULL)
        return RULE_NOMATCH;
    
    // flow:established, to_server;
    if (checkFlow(p, rule64333options[0]->option_u.flowFlags) > 0 ) {
        // content:"signurl.asp", payload http_uri, depth 0, nocase, fast_pattern;
        if (contentMatch(p, rule64333options[1]->option_u.content, &cursor_http_uri) > 0) {
            // content:"SignUrl=", payload http_uri, depth 0, nocase;
            if (contentMatch(p, rule64333options[2]->option_u.content, &cursor_http_uri) > 0) {
                // pcre:"SignUrl=[^\\x26\\s]*[\\x22\\x27\\x28\\x29\\x3C\\x3E]", payload uri, nocase;
                if (pcreMatch(p, rule64333options[3]->option_u.pcre, &cursor_uri)) {
                    return RULE_MATCH;
                }
            }
        }
    }
    return RULE_NOMATCH;
}
// #endif // 0 Don't compile the detection functions if they're not used
/*
Rule *rules[] = {
    &rule64111,
    &rule64222,
    &rule64333,
    NULL
};
*/
